// src/interceptors/user.interceptor.ts
import { CallHandler, ExecutionContext, Injectable, Logger, NestInterceptor } from '@nestjs/common';
import { ClsService } from 'nestjs-cls';
import { Observable } from 'rxjs';

@Injectable()
export class UserInterceptor implements NestInterceptor {
  private readonly logger = new Logger(UserInterceptor.name);

  constructor(private readonly cls: ClsService) {}

  intercept(context: ExecutionContext, next: CallHandler): Observable<any> {
    const request = context.switchToHttp().getRequest();

    // Überprüfe, ob der Benutzer authentifiziert ist
    if (request.user && request.user.email) {
      try {
        this.cls.set('email', request.user.email);
        this.logger.log(`CLS context gesetzt: EMail=${request.user.email}`);
      } catch (error) {
        this.logger.error('Fehler beim Setzen der EMail im CLS-Kontext', error);
      }
    } else {
      this.logger.log('Kein authentifizierter Benutzer gefunden');
    }

    return next.handle();
  }
}
